<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8" />
  <meta http-equiv="X-UA-Compatible" content="IE=edge" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Update Order</title>
  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet"
    href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback" />
  <!-- Font Awesome -->
  <link rel="stylesheet" href="../plugins/fontawesome-free/css/all.min.css" />
  <!-- DataTables -->
  <link rel="stylesheet" href="../plugins/datatables-bs4/css/dataTables.bootstrap4.min.css" />
  <link rel="stylesheet" href="../plugins/datatables-responsive/css/responsive.bootstrap4.min.css" />
  <link rel="stylesheet" href="../plugins/datatables-buttons/css/buttons.bootstrap4.min.css" />

  <!-- Thư viện light box để hiển thị hình ảnh -->
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/lightbox2/2.11.3/css/lightbox.min.css">

  <link rel="stylesheet" href="../css/style-adminpage.css">

    <!-- SweetAlert2 -->
    <link rel="stylesheet" href="../plugins/sweetalert2-theme-bootstrap-4/bootstrap-4.min.css">
    <!-- Toastr -->
    <link rel="stylesheet" href="../plugins/toastr/toastr.min.css">

  <!-- Theme style -->
  <link rel="stylesheet" href="../dist/css/adminlte.min.css" />
  <style>
    i {
      cursor: pointer;
    }
  </style>
  <link rel="stylesheet" href="../css/style-adminpage.css" />
  <link rel="stylesheet" href="../css/responsive-adminpage.css" />


</head>

<body>
  <div class="wrapper">

    <!-- Navbar -->
    <nav class="main-header navbar navbar-expand navbar-white navbar-light">
      <!-- Left navbar links -->
      <ul class="navbar-nav">
        <li class="nav-item">
          <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="../index.html" class="nav-link">Home</a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="../contact.html" class="nav-link">Contact</a>
        </li>
      </ul>

      <!-- Right navbar links -->
      <ul class="navbar-nav ml-auto">
        <!-- Navbar Search -->
        <li class="nav-item">
          <a class="nav-link" data-widget="navbar-search" href="#" role="button">
            <i class="fas fa-search"></i>
          </a>
          <div class="navbar-search-block">
            <form class="form-inline">
              <div class="input-group input-group-sm">
                <input class="form-control form-control-navbar" type="search" placeholder="Search"
                  aria-label="Search" />
                <div class="input-group-append">
                  <button class="btn btn-navbar" type="submit">
                    <i class="fas fa-search"></i>
                  </button>
                  <button class="btn btn-navbar" type="button" data-widget="navbar-search">
                    <i class="fas fa-times"></i>
                  </button>
                </div>
              </div>
            </form>
          </div>
        </li>


        <li class="nav-item">
          <a class="nav-link btn-log-out" role="button">
            <i class="fas fa-sign-out-alt"></i>
          </a>
        </li>
      </ul>
    </nav>
    <!-- /.navbar -->
    <!-- Main Sidebar Container -->
    <aside style="min-height: 100vh;" class="main-sidebar sidebar-dark-primary elevation-4">
      <!-- Sidebar -->
      <!-- Brand Logo -->
      <a href="index3.html" class="brand-link">
        <img src="../dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
          style="opacity: .8">
        <span class="brand-text font-weight-light">Moomap Admin</span>
      </a>

      <!-- Sidebar -->
      <div class="sidebar">
        <!-- Sidebar user panel (optional) -->
        <div class="user-panel mt-3 pb-3 mb-3 d-flex">
          <div class="image">
            <img src="../dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
          </div>
          <div class="info">
            <a href="#" class="d-block">Alexander Pierce</a>
          </div>
        </div>

        <!-- SidebarSearch Form -->
        <div class="form-inline">
          <div class="input-group" data-widget="sidebar-search">
            <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
            <div class="input-group-append">
              <button class="btn btn-sidebar">
                <i class="fas fa-search fa-fw"></i>
              </button>
            </div>
          </div>
        </div>

        <!-- Sidebar Menu -->
        <nav class="mt-2">
          <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
            <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
            <li class="nav-item menu-open">
              <a href="#" class="nav-link">
                <i class="nav-icon fas fa-th"></i>
                <p>
                  Manage
                  <i class="right fas fa-angle-left"></i>
                </p>
              </a>
              <ul class="nav nav-treeview">
                <li class="nav-item">
                  <a href="dashboard.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Dashboard</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="customer.html" class="nav-link ">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Customer</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="order.html" class="nav-link active">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Order</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="product-line.html" class="nav-link ">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Product Line</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="product.html" class="nav-link ">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Product</p>
                  </a>
                </li>

                <li class="nav-item">
                  <a href="rating.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Rating</p>
                  </a>
                </li>

                <li class="nav-item user-manager">
                  <a href="user.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>User</p>
                  </a>
                </li>
              </ul>
            </li>
            <!--  -->
          </ul>
        </nav>
        <!-- /.sidebar-menu -->
      </div>
      <!-- /.sidebar -->
    </aside>

    <!-- Content Wrapper. Contains page content -->
    <div class="content-wrapper">
      <!-- Content Header (Page header) -->
      <div class="content-header">
        <div class="container-fluid">
          <div class="row mb-2">
            <div class="col-sm-6">
              <h1 class="m-0">Order <span class="text-secondary">Update</span></h1>
            </div><!-- /.col -->
            <div class="col-sm-6">
              <ol class="breadcrumb float-sm-right">
                <li class="breadcrumb-item"><a href="dashboard.html">Home</a></li>
                <li class="breadcrumb-item"><a href="order.html">Order</a></li>
                <li class="breadcrumb-item active">Update</li>
              </ol>
            </div><!-- /.col -->
          </div><!-- /.row -->
        </div><!-- /.container-fluid -->
      </div>
      <!-- /.content-header -->

      <!-- Main content -->
      <section class="content">
        <div class="container-fluid">
          <div id="form-product">

            <div class="row mb-2">
              <label for="" class="col-sm-2">Tên khách hàng:</label>
              <div class="col-sm-6 d-flex justify-content-between">
                <select name="select-customer" id="select-customer" class="form-control" disabled>
                </select>
              </div>
              <div class="col-sm-4">
                <button id="btn-view-customer" class="btn btn-primary btn-order"><i class="fas fa-eye"></i></button>
              </div>
            </div>

            <div class="row mb-2">
              <label for="" class="col-sm-2">Địa chỉ nhận hàng:</label>
              <div class="col-sm-6">
                <select name="select-province" id="select-province" class="form-control mb-2" disabled>
                  <option value="none">Chọn tỉnh, thành</option>
                </select>

                <select name="select-district" id="select-district" class="form-control mb-2" disabled>
                  <option value="none">Chọn quận, huyện</option>
                </select>

                <select name="select-ward" id="select-ward" class="form-control" disabled>
                  <option value="none">Chọn phường, xã</option>
                </select>
              </div>
            </div>

            <div class="row mb-2">
              <label for="" class="col-sm-2">Số nhà, đường:</label>
              <div class="col-sm-6">
                <input id="inp-address" type="text" class="form-control" disabled>
              </div>
            </div>

            <div class="row mb-2">
              <label for="" class="col-sm-2">Lời nhắn:</label>
              <div class="col-sm-6">
                <textarea id="txt-message" rows="3" class="form-control" disabled></textarea>
              </div>
            </div>

            <div class="row mb-2">
              <label for="" class="col-sm-2">Giỏ hàng</label>
              <div class="col-sm-6">
                <div class="row">
                  <div class="col-sm-4 col-4">
                    <label for="">Tên sản phẩm</label>
                  </div>
                  <div class="col-sm-4 col-4">
                    <label for="">Số lượng</label>
                  </div>
                  <div class="col-sm-3 col-3">
                    <label for="">Giá tiền</label>
                  </div>
                </div>
              </div>
            </div>

            <div class="cart-row">

            </div>

            <div class="row form-group total">
              <label for="" class="col-sm-2"></label>
              <div class="col-sm-6">
                <div class="row">
                  <div class="col-sm-8 col-8">
                    <h5>Tổng cộng:</h5>
                  </div>
                  <div class="col-sm-4 col-4">
                    <p for=""><span id="span-total-price"></span></p>
                  </div>
                </div>
              </div>
            </div>

            <div class="row pb-5">
              <div class="col-sm-2"></div>
              <div class="col-sm-8">
                <button id="btn-confirm-order" class="btn btn-primary">Xác nhận đơn</button>
                <button id="btn-cancel-order" class="btn btn-warning">Từ chối đơn</button>
                <button id="btn-back-to-order" class="btn btn-secondary">Quay lại</button>
              </div>
            </div>
          </div>

          <!-- Modal xem thông tin khách hàng-->
          <div class="modal fade" id="modal-view-customer">
            <div class="modal-dialog">
              <div class="modal-content">
                <div class="modal-header">
                  <h4 class="modal-title text-primary">Thông tin khách hàng</h4>
                  <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                  </button>
                </div>
                <div class="modal-body">
                  <div class="row form-group">
                    <label for="" class="col-sm-4">Họ</label>
                    <div class="col-sm-8">
                      <input id="inp-first-name" type="text" class="form-control" disabled>
                    </div>
                  </div>

                  <div class="row form-group">
                    <label for="" class="col-sm-4">Tên</label>
                    <div class="col-sm-8">
                      <input id="inp-last-name" type="text" class="form-control" disabled>
                    </div>
                  </div>

                  <div class="row form-group">
                    <label for="" class="col-sm-4">Số điện thoại</label>
                    <div class="col-sm-8">
                      <input id="inp-phone-number" type="text" class="form-control" disabled>
                    </div>
                  </div>

                  <div class="row form-group">
                    <label for="" class="col-sm-4">Email</label>
                    <div class="col-sm-8">
                      <input id="inp-email" type="email" class="form-control" disabled>
                    </div>
                  </div>
                </div>
                <div class="modal-footer">
                </div>
              </div>
            </div>
          </div>

          <!-- Modal log out-->
          <div class="modal fade" id="modal-log-out">
            <div class="modal-dialog modal-sm">
              <div class="modal-content">
                <div class="modal-header">
                  <h5 class="modal-title text-dark">Đăng xuất <i class="fas fa-lock"></i></h5>
                  <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                  </button>
                </div>
                <div class="modal-body">
                  <h6>Bạn có thực sự muốn đăng xuất?</h6>
                </div>
                <div class="modal-footer">
                  <button type="button" class="btn btn-warning" id="btn-confirm-log-out">
                    Đăng xuất
                  </button>
                  <button type="button" class="btn btn-secondary" data-dismiss="modal">
                    Hủy bỏ
                  </button>
                </div>
              </div>
            </div>
          </div>

        </div><!-- /.container-fluid -->
      </section>
      <!-- /.content -->
      <!-- /.content-wrapper -->
    </div>
  </div>
  <footer class="main-footer">
    <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong>
    All rights reserved.
    <div class="float-right d-none d-sm-inline-block">
      <b>Version</b> 3.1.0
    </div>
  </footer>

</body>

<!-- jQuery -->
<script src="../plugins/jquery/jquery.min.js"></script>
<!-- jQuery UI 1.11.4 -->
<script src="../plugins/jquery-ui/jquery-ui.min.js"></script>
<!-- Bootstrap 4 -->
<script src="../plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<!-- DataTables  & Plugins -->
<script src="../plugins/datatables/jquery.dataTables.min.js"></script>
<script src="../plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
<!-- AdminLTE App -->
<script src="../dist/js/adminlte.js"></script>
<!-- THư viện light box để hiển thị hình ảnh -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/lightbox2/2.11.3/js/lightbox.min.js"></script>

<!-- SweetAlert2 -->
<script src="../plugins/sweetalert2/sweetalert2.min.js"></script>
<!-- Toastr -->
<script src="../plugins/toastr/toastr.min.js"></script>

<!-- File js -->
<script src="../js/action.js"></script>

<script>
  "use strict"
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "http://localhost:8080/";
    const gTOKEN = getCookie("token");
    const gBASE_URL_PRODUCT_LINE = "http://localhost:8080/product-lines/";
    const gBASE_URL_PRODUCT = "http://localhost:8080/products/";
    const gBASE_URL_CUSTOMER = "http://localhost:8080/customers/";
    const gBASE_URL_ORDER = "http://localhost:8080/orders/";
    const gBASE_URL_PROVINCE = "http://localhost:8080/provinces/";
    const gBASE_URL_DISTRICT = "http://localhost:8080/districts/";

    const VND = new Intl.NumberFormat('vi-VN', {
      style: 'currency',
      currency: 'VND',
    });

    // Hiển thị thông báo
  var gToast = Swal.mixin({
    toast: true,
    position: 'top-end',
    showConfirmButton: false,
    timer: 3000
  });

    var gProductLineId = null;
    var gProductId = null;
    var gProductSizeId = null;
    var gSelectedCustomer;
    var gCustomerId = null;
    var gOrderId = null;
    var gPositionSaved = null;
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    // Thực thi sự kiện tải trang

    onPageLoading();

    // Thực thi sự kiện khi thay đổi tỉnh thì load ra danh sách huyện tương ứng
    $("#select-province").on("change", function () {
      let vProvinceId = $(this).val();
      let vSelectDistrict = $("#select-district");
      callApiToLoadListDistrictByProvinceId(vProvinceId, vSelectDistrict);
    });

    // Thực thi sự kiện khi thay đổi tỉnh thì load ra danh sách huyện tương ứng trong modal insert customer
    $("#select-province-customer").on("change", function () {
      let vProvinceId = $(this).val();
      let vSelectDistrict = $("#select-district-customer");
      callApiToLoadListDistrictByProvinceId(vProvinceId, vSelectDistrict);
    });

    // Thực thi sự kiện khi thay đổi huyện thì load ra danh sách xã tương ứng
    $("#select-district").on("change", function () {
      let vDistrictId = $(this).val();
      let vSelectWard = $("#select-ward");
      callApiToLoadListWardByDistrictId(vDistrictId, vSelectWard);
    });


    // thực thi sự kiện nhấn nút tạo đơn hàng
    $("#btn-add-order").on("click", function () {
      onBtnCreateOrderClick();
    });

    // Thực thi sự kiện nhấn nút quay lại
    $("#btn-back-to-order").on("click", function () {
      if (gCustomerId != null) {
        window.location.href = "order.html?customerid=" + gCustomerId;
      }
      else {
        window.location.href = "order.html";
      }
    });

    // Thực thi sự kiện nhấn nút xem thông tin khách hàng
    $("#btn-view-customer").on("click", function () {
      onBtnViewCustomerClick();
    });

    // Thực thi sự kiện nhấn nút confirm order
    $("#btn-confirm-order").on("click", function () {
      onBtnConfirmOrderClick();
    });

    // Thực thi sự kiện nhấn nút cancel order
    $("#btn-cancel-order").on("click", function () {
      onBtnCancelOrderClick();
    });

     // Thực thi sự kiện nhấn nút logout
  $(".btn-log-out").on("click", function() {
    $("#modal-log-out").modal("show");
  });

   // Thực thi sự kiện nhấn nút đăng xuất
   $("#btn-confirm-log-out").on("click", function () {
    setCookie("token", "", 1);
    window.location.href = "../login.html";
  });


    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // Hàm sự kiện tải trang
    async function onPageLoading() {
      // Chỗ này để lưu dòng từ &name để trả về đúng vị trí và trạng thái của page order trước khi cập nhật
      if (gTOKEN) {
        callApiToHelloAndAuthenAdminPage();
      }
      else {
        window.location.href = "../login.html";
      }
      let vUrl = window.location.href;
      let vStartIndexPositionSaved = vUrl.indexOf("name=");
      gPositionSaved = vUrl.substring(vStartIndexPositionSaved);
      let vQueryParam = new URLSearchParams(window.location.search);
      gCustomerId = vQueryParam.get("customerid");
      gOrderId = vQueryParam.get("orderid");

      // Hàm gọi API để load dữ liệu tỉnh
      await callApiToLoadDataToSelectProvince();
      await callApiToGetOrderData();
      loadCustomer();
    }

    // Hàm xử lý sự kiện nhấn nút order
    function onBtnCreateOrderClick() {
      let vOrder = {
        province: "",
        district: "",
        ward: "",
        message: "",
        address: "",
        ammount: 0
      }
      // lấy thông tin order
      getDataOrder(vOrder);
      let vValidate = validateOrder(vOrder);
      if (vValidate) {
        callApiToCreateNewOrder(vOrder);
      }
    }

    // Hàm xử lý sự kiện nhấn nút xem thông tin khách hàng
    function onBtnViewCustomerClick() {
      $("#modal-view-customer").modal("show");
      loadDataToModalCustomer();
    }

    // Hàm xử lý sự kiện nhấn nút xác nhận đơn hàng
    function onBtnConfirmOrderClick() {
      let vOrder = {
        status: "confirmed"
      }
      callApiToUpdateOrderStatus(vOrder);
      alertSuccess("Xác nhận đơn hàng thành công!");
    }

    // Hàm xử lý sự kiện nhấn nút xác nhận đơn hàng
    function onBtnCancelOrderClick() {
      let vOrder = {
        status: "cancelled"
      }
      callApiToUpdateOrderStatus(vOrder);
      alertError("Đơn hàng đã bị từ chối!");
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

    // Hàm tính số tiền tổng cộng
    function getTotalPrice() {
      let vListPrice = $(".product-price");
      let vTotalPrice = 0;
      for (let bI = 0; bI < vListPrice.length; bI++) {
        let bPrice = $(vListPrice[bI]).html();
        let bPriceNum = transferCurencytoNumber(bPrice);
        vTotalPrice += bPriceNum;
      }
      let vTotalMoney = VND.format(vTotalPrice);
      $("#span-total-price").html(vTotalMoney);
    }

    // Hàm gọi APi để load dữ liệu vào thẻ select province trong 2 modal insert và update
    function callApiToLoadDataToSelectProvince() {
      $.ajax({
        type: "GET",
        url: gBASE_URL_PROVINCE,
        async: false,
        success: function (paramRes) {
          loadDataToSelectProvince(paramRes);
        },
        error: function (paramError) {
          console.log(paramError.status);
        }
      });
    }

    // Hàm load vào đơn hàng
    function addDataProductToForm(paramDataProduct) {
      // Nếu không thì add sản phẩm mới
      let vItemBox = `<div class="row form-group item-box">
              <label for="" class="col-sm-2"></label>
              <div class="col-sm-6">
                <div class="row"> 
                  <div class="col-sm-4 col-4">
                    <h6  class="product-name">` + paramDataProduct.productName + `<span>(` + paramDataProduct.sizeName + `)</span></h6>
                  </div>
                  <div class="col-sm-4 col-4">
                    <input type="text"  class="w-25 inp-quantity" value="` + paramDataProduct.quantityOrder + `" disabled> 
                  </div>
                  <div class="col-sm-3 col-3">
                    <p><span class="product-price">` + VND.format(paramDataProduct.priceEach * paramDataProduct.quantityOrder) + `</span></p>
                  </div>
                </div>
              </div>
            </div>`
      let vCartRow = $(".cart-row");
      vCartRow.append(vItemBox);
      // Reset form product
    }

    // Hàm load dữ liệu vào thẻ select province
    // Thêm dữ liệu đồng thời vào 2 thẻ select 1 là trong select province ở modal insert customer và 2 là ở ngoài địa chỉ giao hàng
    function loadDataToSelectProvince(paramData) {
      let vSelectProvince = $("#select-province");
      let vSelectProviceCustomer = $("#select-province-customer");
      for (let bI = 0; bI < paramData.length; bI++) {
        $("<option>", {
          value: paramData[bI].id,
          text: paramData[bI].name
        }).appendTo(vSelectProviceCustomer);
        $("<option>", {
          value: paramData[bI].id,
          text: paramData[bI].name
        }).appendTo(vSelectProvince);

      }
    }


    // Hàm gọi API để load ra list district tương ứng bằng province Id
    function callApiToLoadListDistrictByProvinceId(paramProvinceId, paramTag) {
      if (paramProvinceId != "none") {
        $.ajax({
          type: "GET",
          async: false,
          url: gBASE_URL_PROVINCE + paramProvinceId + "/districts",
          success: function (paramRes) {
            loadDataToSelectDistrict(paramTag, paramRes);
          },
          error: function (paramError) {
            console.log(paramError.status);
          }
        });
      }
      else {
        paramTag.html("");
        $("<option>", {
          text: "Chọn quận, huyện",
          value: "none"
        }).appendTo(paramTag);
        paramTag.prop("disabled", true);
        let vSelectWard = $("#select-ward");
        vSelectWard.html("");
        $("<option>", {
          text: "Chọn phường, xã",
          value: "none"
        }).appendTo(vSelectWard);
        vSelectWard.prop("disabled", true);
      }

    }

    // Hàm load data vào thẻ select district
    function loadDataToSelectDistrict(paramTag, paramData) {
      paramTag.html("");
      $("<option>", {
        text: "Chọn quận, huyện",
        value: "none"
      }).appendTo(paramTag);
      for (let bI = 0; bI < paramData.length; bI++) {
        $("<option>", {
          text: paramData[bI].prefix + " " + paramData[bI].name,
          value: paramData[bI].id
        }).appendTo(paramTag);
      }
    }

    // Hàm gọi API để load ra list ward tương ứng bằng district Id
    function callApiToLoadListWardByDistrictId(paramDistrictId, paramTag) {
      if (paramDistrictId != "none") {
        $.ajax({
          type: "GET",
          async: false,
          url: gBASE_URL_DISTRICT + paramDistrictId + "/wards",
          success: function (paramRes) {
            loadDataToSelectWard(paramTag, paramRes);
          },
          error: function (paramError) {
            console.log(paramError.status);
          }
        });
      }
      else {
        paramTag.prop("disabled", true);
        paramTag.html("");
        $("<option>", {
          text: "Chọn phường, xã",
          value: "none"
        }).appendTo(paramTag);
      }
    }

    // Hàm load data vào thẻ select ward
    function loadDataToSelectWard(paramTag, paramData) {
      paramTag.html("");
      $("<option>", {
        text: "Chọn phường, xã",
        value: "none"
      }).appendTo(paramTag);
      for (let bI = 0; bI < paramData.length; bI++) {
        $("<option>", {
          text: paramData[bI].prefix + " " + paramData[bI].name,
          value: paramData[bI].id
        }).appendTo(paramTag);
      }
    }

    // Hàm xử lý sau khi tạo sản phẩm thành công
    function handleCreateProductSuccess() {
      alertSuccess("Tạo mới sản phẩm thành công!");
      window.location.href = "product.html";
    }

    // Hàm validate khi nhập số lượng 
    function validateInputQuantity(paramTag) {
      let vMaxQuantity = $(paramTag).attr("max");
      let vQuantity = $(paramTag).val();
      if (parseInt(vQuantity) < 1) {
        alertWarning("Số lượng phải ít nhất là 1!");
        $(paramTag).val(1);
        return false;
      }
      if (parseInt(vQuantity) > parseInt(vMaxQuantity)) {
        alertWarning("Vui lòng nhập số lượng ít hơn hoặc bằng số lượng hiện có!");
        $(paramTag).val(1);
        return false;
      }
      return true;
    }

    // Hàm gọi API để lấy thông tin khách hàng
    function callApiToGetCustomerData(paramCustomerId) {
      $.ajax({
        type: "GET",
        url: gBASE_URL_CUSTOMER + paramCustomerId,
        success: function (paramRes) {
          gSelectedCustomer = paramRes;
          addCustomerDataToSelectCustomer(paramRes);
        },
        error: function (paramError) {
          console.log(paramError.status);
        }
      });
    }

    // Điền dữ liệu khách hàng vào thẻ select
    function addCustomerDataToSelectCustomer(paramCustomerData) {
      let vSelectCustomer = $("#select-customer");
      $("<option>", {
        value: paramCustomerData.id,
        text: paramCustomerData.firstName + " " + paramCustomerData.lastName
      }).appendTo(vSelectCustomer);
    }

    // Hàm lấy thông tin order
    function getDataOrder(paramOrderData) {
      paramOrderData.province = $("#select-province option:selected").text();
      paramOrderData.district = $("#select-district option:selected").text();
      paramOrderData.ward = $("#select-ward option:selected").text();
      paramOrderData.address = $("#inp-address").val().trim();
      paramOrderData.message = $("#txt-message").val().trim();
      let vTotalPrice = $("#span-total-price").html().trim()
      paramOrderData.ammount = transferCurencytoNumber(vTotalPrice);
    }

    // Hàm validate dữ liệu order
    function validateOrder(paramOrderData) {
      if (gSelectedCustomer == null) {
        alertWarning("Vui lòng chọn khách hàng!");
        return false;
      }

      if (paramOrderData.ammount == 0) {
        alertWarning("Giỏ hàng phải có ít nhất 1 sản phẩm!");
        return false;
      }

      if (paramOrderData.province == "Chọn tỉnh, thành") {
        alertWarning("Vui lòng chọn tỉnh nhận hàng!");
        return false;
      }

      if (paramOrderData.district == "Chọn quận, huyện") {
        alertWarning("Vui lòng chọn quận huyện nhận hàng!");
        return false;
      }

      if (paramOrderData.ward == "Chọn phường, xã") {
        alertWarning("Vui lòng chọn phường, xã nhận hàng!");
        return false;
      }

      if (paramOrderData.address == "") {
        alertWarning("Vui lòng nhập địa chỉ cụ thể!");
        return false;
      }
      return true;
    }

    // Hàm gọi APi để thêm mới 1 order
    function callApiToCreateNewOrder(paramOrderData) {
      $.ajax({
        type: "POST",
        url: gBASE_URL_CUSTOMER + gSelectedCustomer.id + "/orders",
        contentType: "application/json",
        data: JSON.stringify(paramOrderData),
        async: false,
        success: function (paramRes) {
          createOrderDetail(paramRes);
          alertSuccess("Tạo mới đơn hàng thành công!");
          window.location.href = "order.html";
        },
        error: function (paramError) {
          alertError("Tạo mới đơn hàng thất bại, vui lòng thử lại!");
          console.log(paramError.status);
        }
      });
    }

    // Hàm xử lý sự kiện nhấn nút xác nhận thêm mới 1 khách hàng trong modal insert
    function onBtnConfirmAddCustomer() {
      let vCustomer = {
        firstName: "",
        lastName: "",
        phoneNumber: "",
        email: "",
        province: "",
        district: "",
        ward: "",
        address: ""
      }
      getDataInsert(vCustomer);
      let vValidate = validateCustomerData(vCustomer);
      if (vValidate) {
        console.log(vCustomer);
        callApiToCreateNewCustomer(vCustomer);
      }
    }

    // Get data to form modal insert
    function getDataInsert(paramDataInsert) {
      paramDataInsert.firstName = $("#inp-first-name").val().trim();
      paramDataInsert.lastName = $("#inp-last-name").val().trim();
      paramDataInsert.phoneNumber = $("#inp-phone-number").val().trim();
      paramDataInsert.email = $("#inp-email").val().trim();
      paramDataInsert.province = $("#select-province-customer option:selected").text();
      paramDataInsert.district = $("#select-district-customer option:selected").text();
      paramDataInsert.ward = $("#select-ward-customer option:selected").text();
      paramDataInsert.address = $("#inp-address-detail-customer").val().trim();
    }

    // Hàm validate dữ liệu khách hàng
    function validateCustomerData(paramData) {
      if (paramData.firstName == "") {
        alertWarning("Vui lòng nhập họ của khách hàng");
        return false;
      }
      if (paramData.lastName == "") {
        alertWarning("Vui lòng nhập tên của khách hàng");
        return false;
      }
      if (paramData.phoneNumber == "") {
        alertWarning("Vui lòng nhập số điện thoại của khách hàng");
        return false;
      }

      if (!validatePhoneNumber(paramData.phoneNumber)) {
        alertWarning("Số điện thoại khách hàng chưa đúng định dạng");
        return false;
      }

      if (paramData.email != "" && !validateEmail(paramData.email)) {
        alertWarning("Email khách hàng chưa đúng định dạng");
        return false;
      }

      if (paramData.province == "Chọn tỉnh, thành phố") {
        alertWarning("Vui lòng chọn tỉnh thành phố của khách hàng");
        return false;
      }

      if (paramData.district == "Chọn quận, huyện") {
        alertWarning("Vui lòng chọn quận huyện của khách hàng");
        return false;
      }

      if (paramData.district == "Chọn phường, xã") {
        alertWarning("Vui lòng chọn phường, xã của khách hàng");
        return false;
      }
      return true;
    }

    // Hàm validate số điện thoại
    function validatePhoneNumber(paramPhoneNumber) {
      let vPhoneNumber = paramPhoneNumber.replace(/\D/g, '');
      if (vPhoneNumber.length === 10 && vPhoneNumber.charAt(0) === "0") {
        return true;
      }
      return false;
    }

    // Hàm validate Email
    function validateEmail(paramEmail) {
      var emailPattern = /^[^\s@]+@[^\s@]+\.[^\s@]+$/;
      return emailPattern.test(paramEmail);
    }

    // Hàm gọi APi để tạo mới thông tin khách hàng
    function callApiToCreateNewCustomer(paramCustomerData) {
      $.ajax({
        type: "POST",
        url: gBASE_URL_CUSTOMER,
        contentType: "application/json",
        data: JSON.stringify(paramCustomerData),
        success: function (paramRes) {
          handleCreateCustomerSuccess(paramRes);
        },
        error: function (paramError) {
          alertError("Tạo mới khách hàng thất bại, vui lòng thử lại");
          $("#modal-insert-customer").modal("hide");
          console.log(paramError.status);
        }
      });
    }

    // Hàm xử lý sau khi tạo thành công dữ liệu khách hàng
    function handleCreateCustomerSuccess(paramCustomerData) {
      alertSuccess("Tạo mới khách hàng thành công!");
      callApiToLoadListCustomer();
      $("#modal-insert-customer").modal("hide");
      resetDataInsert();
    }

    // Hàm reset dữ liệu từ form insert
    function resetDataInsert() {
      $("#inp-first-name").val("");
      $("#inp-last-name").val("");
      $("#inp-phone-number").val("");
      $("#inp-email").val("");
      $("#select-province-customer").val("none");
      $("#select-district-customer").val("none");
      $("#select-ward-customer").val("none");
      $("#inp-address-detail-customer").val("");
    }

    // Hàm lấy thông tin khách hàng khi truyền id vào
    function loadCustomer() {
      if (gCustomerId != null) {
        callApiToGetCustomerData(gCustomerId);
      }
    }

    // Hàm chuyển tiền tệ thành số
    function transferCurencytoNumber(paramCurrency) {
      return parseFloat(paramCurrency.replace(/[.,đ]/g, ''));
    }

    // Hàm lấy thông tin khách hàng thông qua số điện thoại
    function callApiToGetCustomerDataByPhoneNumber(paramPhoneNumber) {
      $.ajax({
        type: "GET",
        url: gBASE_URL_CUSTOMER + "phone/" + paramPhoneNumber,
        success: function (paramRes) {
          gSelectedCustomer = paramRes;
          addCustomerDataToSelectCustomer(paramRes);
        },
        error: function (paramError) {
          console.log(paramError.status);
        }
      });
    }

    // Hàm ogij APi để lấy thông tin order
    function callApiToGetOrderData() {
      $.ajax({
        type: "GET",
        url: gBASE_URL_ORDER + gOrderId,
        async: false,
        success: function (paramRes) {
          loadDataToFormUpdate(paramRes);
          callApiToGetCustomerDataByPhoneNumber(paramRes.phoneNumber);
        },
        error: function (paramError) {
          console.log(paramError.status);
        }
      });
    }

    // Hàm load dữ liệu trả về vào form update
    function loadDataToFormUpdate(paramData) {
      let vSelectProvince = $("#select-province");
      let vTargetOptionProvince = vSelectProvince.find("option:contains(" + paramData.province + ")");
      vTargetOptionProvince.prop("selected", true);

      // Call api to load list district by province ID
      let vProvinceId = vSelectProvince.val();
      let vSelectDistrict = $("#select-district");
      callApiToLoadListDistrictByProvinceId(vProvinceId, vSelectDistrict);

      // Set text for select district
      let vTargetOptionDistrict = vSelectDistrict.find("option:contains(" + paramData.district + ")");
      vTargetOptionDistrict.prop("selected", true);

      // call api to load list ward by district ID
      let vDistrictId = vSelectDistrict.val();
      let vSelectWard = $("#select-ward");
      callApiToLoadListWardByDistrictId(vDistrictId, vSelectWard);

      // Set text for select ward
      let vTargetOptionWard = vSelectWard.find("option:contains(" + paramData.ward + ")");
      vTargetOptionWard.prop("selected", true);

      $("#inp-address").val(paramData.address);
      $("#txt-message").val(paramData.message);

      // Hàm đưa load món hàng đã mua vào
      loadItemInCart(paramData.orderDetails);

      // Đưa giá tiền tổng vào
      $("#span-total-price").html(VND.format(paramData.ammount));
    }

    // Hàm load các item vào giỏ hàng
    function loadItemInCart(paramListItem) {
      for (let bI = 0; bI < paramListItem.length; bI++) {
        addDataProductToForm(paramListItem[bI]);
      }
    }

    // Hàm load dữ liệu vào modal customer
    function loadDataToModalCustomer() {
      $("#inp-first-name").val(gSelectedCustomer.firstName);
      $("#inp-last-name").val(gSelectedCustomer.lastName);
      $("#inp-email").val(gSelectedCustomer.email);
      $("#inp-phone-number").val(gSelectedCustomer.phoneNumber);
    }

    // Hàm cập nhật trạng thái đơn hàng
    function callApiToUpdateOrderStatus(paramOrderData) {
      console.log(paramOrderData);
      $.ajax({
        type: "PUT",
        url: gBASE_URL_ORDER + gOrderId,
        contentType: "application/json",
        data: JSON.stringify(paramOrderData),
        success: function (paramRes) {
          handleOnUpdateOrderSuccess();
        },
        error: function (paramError) {
          alertError("Cập nhật đơn hàng thất bại, vui lòng thử lại!");
          console.log(paramError.status);
        }
      });
    }

    // Hàm xử lý sau khi cập nhật thành công
    function handleOnUpdateOrderSuccess() {
      if (gCustomerId != null) {
        window.location.href = "order.html?customerid=" + gCustomerId + "&" + gPositionSaved;
      }
      else {
        window.location.href = "order.html?" + gPositionSaved;
      }
    }

    



</script>

</html>